>From 00734ee1e69b06e46fce07dc2bd206f5e05f1f23 Mon Sep 17 00:00:00 2001
From: Brendan Jones <brendan.jones.it@gmail.com>
Date: Fri, 25 Jul 2014 08:31:39 +0200
Subject: [PATCH 1/2] Add Audio Production (audio) group.

---
 comps-f22.xml.in | 120 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 120 insertions(+)

diff --git a/comps-f22.xml.in b/comps-f22.xml.in
index 4766269..2d44c9e 100644
--- a/comps-f22.xml.in
+++ b/comps-f22.xml.in
@@ -1127,6 +1127,126 @@
     </packagelist>
   </group>
   <group>
+    <id>audio</id>
+    <_name>Audio Production</_name>
+    <_description>Various tools for audio synthesis and music production.</_description>
+    <default>false</default>
+    <uservisible>true</uservisible>
+    <packagelist>
+      <packagereq type="optional">Add64</packagereq>
+      <packagereq type="optional">a2jmidid</packagereq>
+      <packagereq type="optional">aj-snapshot</packagereq>
+      <packagereq type="optional">alsa-firmware</packagereq>
+      <packagereq type="optional">alsa-plugins-jack</packagereq>
+      <packagereq type="optional">alsa-plugins-samplerate</packagereq>
+      <packagereq type="optional">alsa-plugins-upmix</packagereq>
+      <packagereq type="optional">alsa-plugins-usbstream</packagereq>
+      <packagereq type="optional">alsa-plugins-vdownmix</packagereq>
+      <packagereq type="optional">alsa-tools</packagereq>
+      <packagereq type="optional">alsa-utils</packagereq>
+      <packagereq type="optional">alsamixergui</packagereq>
+      <packagereq type="optional">ams</packagereq>
+      <packagereq type="optional">ardour3</packagereq>
+      <packagereq type="optional">arpage</packagereq>
+      <packagereq type="optional">audacity</packagereq>
+      <packagereq type="optional">bristol</packagereq>
+      <packagereq type="optional">calf</packagereq>
+      <packagereq type="optional">drumkv1</packagereq>
+      <packagereq type="optional">dssi</packagereq>
+      <packagereq type="optional">fluid-soundfont-gm</packagereq>
+      <packagereq type="optional">fluidsynth</packagereq>
+      <packagereq type="optional">fluidsynth-dssi</packagereq>
+      <packagereq type="optional">frescobaldi</packagereq>
+      <packagereq type="optional">gladish</packagereq>
+      <packagereq type="optional">guitarix</packagereq>
+      <packagereq type="optional">harmonyseq</packagereq>
+      <packagereq type="optional">hexter-dssi</packagereq>
+      <packagereq type="optional">hydrogen</packagereq>
+      <packagereq type="optional">idjc</packagereq>
+      <packagereq type="optional">jaaa</packagereq>
+      <packagereq type="optional">jack-audio-connection-kit</packagereq>
+      <packagereq type="optional">jack-audio-connection-kit-dbus</packagereq>
+      <packagereq type="optional">jack-rack</packagereq>
+      <packagereq type="optional">jack_capture</packagereq>
+      <packagereq type="optional">jackctlmmc</packagereq>
+      <packagereq type="optional">jamin</packagereq>
+      <packagereq type="optional">japa</packagereq>
+      <packagereq type="optional">jmeters</packagereq>
+      <packagereq type="optional">kernel-tools</packagereq>
+      <packagereq type="optional">ladish</packagereq>
+      <packagereq type="optional">ladspa</packagereq>
+      <packagereq type="optional">ladspa-amb-plugins</packagereq>
+      <packagereq type="optional">ladspa-autotalent-plugins</packagereq>
+      <packagereq type="optional">ladspa-blop-plugins</packagereq>
+      <packagereq type="optional">ladspa-cmt-plugins</packagereq>
+      <packagereq type="optional">ladspa-fil-plugins</packagereq>
+      <packagereq type="optional">ladspa-mcp-plugins</packagereq>
+      <packagereq type="optional">ladspa-rev-plugins</packagereq>
+      <packagereq type="optional">ladspa-swh-plugins</packagereq>
+      <packagereq type="optional">ladspa-tap-plugins</packagereq>
+      <packagereq type="optional">ladspa-vco-plugins</packagereq>
+      <packagereq type="optional">lash</packagereq>
+      <packagereq type="optional">lilypond</packagereq>
+      <packagereq type="optional">lv2</packagereq>
+      <packagereq type="optional">lv2-abGate</packagereq>
+      <packagereq type="optional">lv2-artyfx-plugins</packagereq>
+      <packagereq type="optional">lv2-avw-plugins</packagereq>
+      <packagereq type="optional">lv2-c++-tools </packagereq>
+      <packagereq type="optional">lv2-drumkv1</packagereq>
+      <packagereq type="optional">lv2-fabla</packagereq>
+      <packagereq type="optional">lv2-fil-plugins</packagereq>
+      <packagereq type="optional">lv2-fomp-plugins</packagereq>
+      <packagereq type="optional">lv2-invada-plugins</packagereq>
+      <packagereq type="optional">lv2-kn0ck0ut</packagereq>
+      <packagereq type="optional">lv2-ll-plugins</packagereq>
+      <packagereq type="optional">lv2-newtonator</packagereq>
+      <packagereq type="optional">lv2-samplv1</packagereq>
+      <packagereq type="optional">lv2-sorcer</packagereq>
+      <packagereq type="optional">lv2-swh-plugins</packagereq>
+      <packagereq type="optional">lv2-synthv1</packagereq>
+      <packagereq type="optional">lv2-triceratops</packagereq>
+      <packagereq type="optional">lv2-vocoder-plugins</packagereq>
+      <packagereq type="optional">lv2-x42-plugins</packagereq>
+      <packagereq type="optional">lv2-zynadd-plugins</packagereq>
+      <packagereq type="optional">lv2dynparam</packagereq>
+      <packagereq type="optional">monobristol</packagereq>
+      <packagereq type="optional">mscore</packagereq>
+      <packagereq type="optional">multimedia-menus</packagereq>
+      <packagereq type="optional">mup</packagereq>
+      <packagereq type="optional">muse</packagereq>
+      <packagereq type="optional">nekobee-dssi</packagereq>
+      <packagereq type="optional">non-daw</packagereq>
+      <packagereq type="optional">non-mixer</packagereq>
+      <packagereq type="optional">non-sequencer</packagereq>
+      <packagereq type="optional">non-session-manager</packagereq>
+      <packagereq type="optional">qastools</packagereq>
+      <packagereq type="optional">qjackctl</packagereq>
+      <packagereq type="optional">qmidiarp</packagereq>
+      <packagereq type="optional">qsynth</packagereq>
+      <packagereq type="optional">qtractor</packagereq>
+      <packagereq type="optional">radium-compressor</packagereq>
+      <packagereq type="optional">rakarrack</packagereq>
+      <packagereq type="optional">realTimeConfigQuickScan</packagereq>
+      <packagereq type="optional">rosegarden4</packagereq>
+      <packagereq type="optional">rtirq</packagereq>
+      <packagereq type="optional">samplv1</packagereq>
+      <packagereq type="optional">seq24</packagereq>
+      <packagereq type="optional">sooperlooper</packagereq>
+      <packagereq type="optional">swami</packagereq>
+      <packagereq type="optional">synthv1</packagereq>
+      <packagereq type="optional">timidity++</packagereq>
+      <packagereq type="optional">tuxguitar</packagereq>
+      <packagereq type="optional">vmpk</packagereq>
+      <packagereq type="optional">whysynth-dssi</packagereq>
+      <packagereq type="optional">xsynth-dssi</packagereq>
+      <packagereq type="optional">yoshimi</packagereq>
+      <packagereq type="optional">zita-at1</packagereq>
+      <packagereq type="optional">zita-rev1</packagereq>
+      <packagereq type="optional">zynaddsubfx</packagereq>
+      <packagereq type="optional">zynjacku</packagereq>
+    </packagelist>
+  </group>
+  <group>
     <id>authoring-and-publishing</id>
     <_name>Authoring and Publishing</_name>
     <_description>These tools allow you to create documents in the DocBook format and convert them into HTML, PDF, Postscript, and text.</_description>
-- 
1.9.3